package de.jatitv.commandguiv2.api;

import de.jatitv.commandguiv2.Spigot.Listener.ItemChange;
import de.jatitv.commandguiv2.Spigot.Listener.UseItem_Listener.Events_from1_10;
import de.jatitv.commandguiv2.Spigot.Main;
import de.jatitv.commandguiv2.Spigot.cmdManagement.Commands;
import de.jatitv.commandguiv2.Spigot.cmdManagement.Help;
import de.jatitv.commandguiv2.Spigot.system.config.DefaultGUICreate;
import de.jatitv.commandguiv2.Spigot.system.config.languages.SelectMessages;
import de.jatitv.commandguiv2.Spigot.system.database.Select_Database;
import de.jatitv.commandguiv2.Spigot.Listener.UseItem_Listener.Events;
import net.t2code.lib.Spigot.Lib.minecraftVersion.MCVersion;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CGuiAPI {
    public static Boolean JoinDisable = false;

    public static void onItemChange(Player player) {
        ItemChange.itemChange(player);
    }

    public static void disableItemGiveOnJoin(Boolean disableItemGiveOnJoin) {
        JoinDisable = disableItemGiveOnJoin;
    }

    public static Boolean selectPlayerItemEnable(Player player) {
        return Select_Database.selectItemStatus(player);
    }

    public static Integer selectPlayerItemSlot(Player player) {
        return Select_Database.selectSlot(player);
    }

    public static void setPlayerItemEnable(Player player, Boolean value) {
        if (value) {
            Select_Database.setItemStatusTrue(player);
        } else Select_Database.setItemStatusFalse(player);
    }

    public static void setPlayerItemSlot(Player player, Integer value) {
        Select_Database.setSlot(player, value);
    }

    public static void openDefaultGUI(Player player) {
        Commands.gui(player);
    }

    public static void openGUI(Player player, String GUI_CommandName) {
        Commands.gui(player, GUI_CommandName);
    }

    public static void sendHelp(CommandSender sender) {
        Help.sendHelp(sender, Main.prefix);
    }

    public static void sendPluginInfo(CommandSender sender) {
        if (sender.hasPermission("commandgui.command.info")) {
            Commands.info(sender);
        } else sender.sendMessage(SelectMessages.NoPermissionForCommand
                .replace("[cmd]", "/commandgui admin").replace("[perm]", "commandgui.command.info"));
    }

    public static void createDefaultGUI(CommandSender sender) {
        if (sender.hasPermission("commandgui.admin")) {
            DefaultGUICreate.configCreate();
            sender.sendMessage(SelectMessages.DefaultGUIcreate.replace("[directory]", Main.getPath() + "\\GUIs\\default.yml"));
        } else sender.sendMessage(SelectMessages.NoPermissionForCommand
                .replace("[cmd]", "/commandgui admin").replace("[perm]", "commandgui.admin"));
    }

    public static void reload(CommandSender sender) {
        if (sender.hasPermission("commandgui.admin")) {
            Commands.reload(sender);
        } else sender.sendMessage(SelectMessages.NoPermissionForCommand
                .replace("[cmd]", "/commandgui admin").replace("[perm]", "commandgui.admin"));
    }


}
